
import java.io.IOException;
import java.io.InputStream;
import java.io.File;
import java.io.OutputStream;

public class Parent {

  public static void main(String[] args) throws Exception {

    System.out.println("Parent: Starting.");

    final ProcessBuilder pb = new ProcessBuilder(
      System.getProperty("java.home") + File.separator + "bin" +
                                        File.separator + "java",
      "Child"
    );
    
    pb.directory(new File(System.getProperty("user.dir")));
    final Process p = pb.start();

    p.getOutputStream().close();

    // pump child's stderr to our own stderr
    new Thread(
      new StreamPump(p.getErrorStream(), System.err),
      "err pump"
    ).start();

    // pump child's stdout to our own stdout
    new Thread(
      new StreamPump(p.getInputStream(), System.out),
      "out pump"
    ).start();   

    p.waitFor();

    System.out.println("Parent: Stopping.");
  }

  private static class StreamPump implements Runnable {
    private final InputStream in;
    private final OutputStream out;

    public StreamPump(InputStream in, OutputStream out) {
      this.in = in;
      this.out = out;
    }

    public void run() {
      try {
        final byte[] buffer = new byte[4096];
        int n = 0;
        while ((n = in.read(buffer)) >= 0) out.write(buffer, 0, n);
      }
      catch (IOException e) {
        e.printStackTrace();
      }
    }
  }
}
